package org.exoplatform.portlets.content.admin.component;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.actions.component.UIActionTypeList;
import org.exoplatform.portlets.content.rules.component.UIRuleList;
import org.exoplatform.portlets.content.script.component.UIScriptList;
import org.exoplatform.portlets.content.templates.component.UITemplatesManager;

public class UIECMAdminSummary extends UIExoCommand{
  
  private static String MANAGE_TEMPLATES_ACTION = "manageTemplates".intern() ;
  private static String MANAGE_SCRIPTS_ACTION = "manageScripts".intern() ;
  private static String MANAGE_RULES_ACTION = "manageRules".intern() ;
  private static String CREATE_ACTIONS_TYPE_ACTION = "createActionType".intern() ;

  static Parameter[] MANAGE_TEMPLATES_PARAMS = { new Parameter(ACTION , MANAGE_TEMPLATES_ACTION)} ;
  static Parameter[] MANAGE_SCRIPTS_PARAMS = { new Parameter(ACTION , MANAGE_SCRIPTS_ACTION)} ;
  static Parameter[] MANAGE_RULES_PARAMS = { new Parameter(ACTION , MANAGE_RULES_ACTION)} ;
  static Parameter[] CREATE_MOVE_TYPE_PARAMS = { new Parameter(ACTION , CREATE_ACTIONS_TYPE_ACTION)} ;  
  

  public UIECMAdminSummary() {
    setRendererType("VelocityRenderer") ;
    setId("UICMSAdminSummary");    
    
    addActionListener(ManageTemplatesActionListener.class, MANAGE_TEMPLATES_ACTION);
    addActionListener(ManageScriptsActionListener.class, MANAGE_SCRIPTS_ACTION);
    addActionListener(ManageRulesActionListener.class, MANAGE_RULES_ACTION);
    addActionListener(CreateActionTypeActionListener.class, CREATE_ACTIONS_TYPE_ACTION);    
  }
  
  public Parameter[] getManageTemplatesParams() { return MANAGE_TEMPLATES_PARAMS ; }
  public Parameter[] getManageScriptsParams() { return MANAGE_SCRIPTS_PARAMS ; }
  public Parameter[] getManageRulesParams() { return MANAGE_RULES_PARAMS ; }
  public Parameter[] getCreateActionTypeParams() { return CREATE_MOVE_TYPE_PARAMS ; }  
  
  
  static public class ManageTemplatesActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIECMAdminSummary uicomp = (UIECMAdminSummary) event.getComponent() ;      
      uicomp.setRenderedSibling(UITemplatesManager.class) ;
    }
  }    
  
  static public class ManageScriptsActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIECMAdminSummary uicomp = (UIECMAdminSummary) event.getComponent() ;      
      uicomp.setRenderedSibling(UIScriptList.class) ;
    }
  }    

  static public class ManageRulesActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIECMAdminSummary uicomp = (UIECMAdminSummary) event.getComponent() ;      
      uicomp.setRenderedSibling(UIRuleList.class) ;
    }
  }      
  
  static public class CreateActionTypeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIECMAdminSummary uicomp = (UIECMAdminSummary) event.getComponent() ;      
      uicomp.setRenderedSibling(UIActionTypeList.class) ;
    }
  }  
  
}
