/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.util.Collection;

import javax.jcr.Node;
import javax.jcr.PropertyType;
import javax.jcr.Value;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.jcr.core.ExtendedPropertyType;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
public class UINodeTypeInfo extends UIExoCommand  implements ChangeNodeListener {  

  private Collection nodetypes  ;
  static Parameter [] BACK_PARAMS = { new Parameter(ACTION , CANCEL_ACTION) } ;
  public UINodeTypeInfo() {
    setRendererType("VelocityRenderer") ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public Parameter[] getBackParams(){ return BACK_PARAMS ; } 
  public Collection getNodeTypes()  {  return nodetypes; }
  public void       setNodeTypes(Collection types) { nodetypes = types ; }
  
  public void  onChange(UIJCRExplorer uiExplorer, Node node)  throws Exception {
    setRendered(false) ;
    NodeType nt ;
  }
  
  public String resolveType(int type) {
    return ExtendedPropertyType.nameFromValue(type);
  }
  
  public String resolveOnParentVersion(int opv) {
    return OnParentVersionAction.nameFromValue(opv);
  }
  
  public String toStringDefaultValues(PropertyDefinition def) throws Exception {
    Value[] values = def.getDefaultValues() ;
    if(values == null || values.length == 0 ) return "" ; 
    StringBuffer b = new StringBuffer() ;
    for(int i = 0; i < values.length; i++) {
      if(values[i] == null) continue ;
      b.append(values[i].getString()).append("<br/>") ;
    }
    return b.toString() ;
  }
  
  public String toStringConstraints(PropertyDefinition def) throws Exception {
    String[] values = def.getValueConstraints() ;
    if(values == null || values.length == 0 ) return "" ; 
    StringBuffer b = new StringBuffer() ;
    for(int i = 0; i < values.length; i++) {
      b.append(values[i]).append("<br/>") ;
    }
    return b.toString() ;
  }  
  
}