package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.jcr.component.model.Preference;

public class UIPreferencesForm extends UISimpleForm {
  
  public static final String DISPLAY_TYPE = "displayType";
  public static final String CHECKBOX = "checkbox";
  public static final String SORT_TYPE = "sortType";
  public static final String ORDER = "order";
  
  public UIPreferencesForm() {
    super("preferencesForm", "post", null) ;    
    setRendererType("SimpleFormVelocityRenderer");
    
    List browsingOptions = new ArrayList() ;
    browsingOptions.add(new SelectItem(Preference.LIST_TYPE, Preference.LIST_TYPE));
    browsingOptions.add(new SelectItem(Preference.THUMBNAIL_TYPE, Preference.THUMBNAIL_TYPE));
    browsingOptions.add(new SelectItem(Preference.MAC_TYPE, Preference.MAC_TYPE));
    UISelectBox uiSelectBrowsingOptions = new  UISelectBox(DISPLAY_TYPE, "", browsingOptions) ;
    add(uiSelectBrowsingOptions);
    
    add(new UICheckBox(CHECKBOX, "false"));
    
    List sortOptions = new ArrayList() ;
    sortOptions.add(new SelectItem(Preference.ALPHABETICAL_SORT, Preference.ALPHABETICAL_SORT));
    sortOptions.add(new SelectItem(Preference.TYPE_SORT, Preference.TYPE_SORT));
    UISelectBox uiSelectSortOptions = new  UISelectBox(SORT_TYPE, "", sortOptions) ;
    add(uiSelectSortOptions);
    
    List orderOptions = new ArrayList() ;
    orderOptions.add(new SelectItem(Preference.ASCENDING_ORDER, Preference.ASCENDING_ORDER));
    orderOptions.add(new SelectItem(Preference.DESCENDING_ORDER, Preference.DESCENDING_ORDER));
    UISelectBox uiSelectOrderOptions = new  UISelectBox(ORDER, "", orderOptions) ;
    add(uiSelectOrderOptions);

    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPreferencesForm uicomp = (UIPreferencesForm) event.getSource() ;
      UIJCRExplorer explorer = (UIJCRExplorer) uicomp.getSibling(UIJCRExplorer.class);
      
      String display = uicomp.getUIInput(DISPLAY_TYPE).getValue();
      UICheckBox box = (UICheckBox) uicomp.getUIInput(CHECKBOX);
      boolean jcrEnable = new Boolean(box.getSelect()).booleanValue();
      String sort = uicomp.getUIInput(SORT_TYPE).getValue();
      String order = uicomp.getUIInput(ORDER).getValue();
      Preference pref = explorer.getPreference();
      
      pref.setDisplayType(display);
      pref.setJcrEnable(jcrEnable);
      pref.setSort(sort);
      pref.setOrder(order);
      uicomp.setRenderedSibling(UIJCRExplorer.class);
    }
  }  
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPreferencesForm uicomp = (UIPreferencesForm) event.getSource() ;
      uicomp.setRenderedSibling(UIJCRExplorer.class);      
    }
  }    

}
