package org.exoplatform.services.cms.actions;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

public class MoveMixin extends NodeTypeImpl {

  public MoveMixin(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:move";
    this.mixin = true;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[2];    
    
    this.declaredPropertyDefinitions[0] = 
        new PropertyDefinitionImpl("exo:destWorkspace",  //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            NULL_VALUES,                        //defaultValues
                            false,                       //autoCreate       
                            true,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
      ); 
    
    this.declaredPropertyDefinitions[1] = 
        new PropertyDefinitionImpl("exo:destPath",       //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            NULL_VALUES,                        //defaultValues
                            false,                       //autoCreate       
                            true,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
      );
  }
}