package org.exoplatform.services.cms.scripts;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

public class SendMailScriptType extends NodeTypeImpl{
  
  public SendMailScriptType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:sendMailAction";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("exo:scriptAction");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[2];   

    Value[] defaultValues = {new StringValue("SendMailScript.groovy")};
    this.declaredPropertyDefinitions[0] = 
      new PropertyDefinitionImpl("exo:script",         //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          defaultValues,               //defaultValues
                          true,                        //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.IGNORE,//onVersion        
                          true,                        //readOnly         
                          false                        //multiple         
      );    
    
    this.declaredPropertyDefinitions[1] = 
      new PropertyDefinitionImpl("exo:to",             //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          null,                        //defaultValues
                          false,                       //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.IGNORE,//onVersion        
                          false,                       //readOnly         
                          false                        //multiple         
      );    
    
    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }
  
}

