package org.exoplatform.services.cms.workflow;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

public class WorkflowType extends NodeTypeImpl {

  public WorkflowType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:workflowAction";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("exo:businessProcessAction");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    
    this.declaredPropertyDefinitions[0] = 
        new PropertyDefinitionImpl("exo:validator",      //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            null,                        //defaultValues
                            false,                       //autoCreate       
                            true,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
        );

    Value[] defaultValues = {new StringValue("content-validation")};
    this.declaredPropertyDefinitions[1] = 
      new PropertyDefinitionImpl("exo:businessProcess",//name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          defaultValues,               //defaultValues
                          true,                        //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.IGNORE,//onVersion        
                          true,                        //readOnly         
                          false                        //multiple         
      );    
    
    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }
}
