/*
 * Created on Mar 3, 2005
 */
package org.exoplatform.services.cms.impl;

import javax.jcr.Node;
import javax.jcr.Repository;
import javax.jcr.SimpleCredentials;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.cms.templates.TemplateService;
import org.exoplatform.services.jcr.RepositoryService;
import org.exoplatform.services.jcr.impl.core.RepositoryImpl;
import org.exoplatform.services.jcr.impl.core.SessionImpl;
import org.exoplatform.services.log.LogService;
import org.exoplatform.services.organization.OrganizationService;

import junit.framework.TestCase;

/**
 * @author benjaminmestrallet
 */
public class BaseTest extends TestCase{
  
  protected static final String WORKSPACE = "ws";
  protected Repository repository_;
  protected SimpleCredentials credentials_;
  protected PortalContainer servicesManager_;
  protected OrganizationService orgService;
  protected TemplateService dialogService_;
  private SessionImpl session;
  private Node root;

  public void setUp() throws Exception{
    
    LogService logService = (LogService) RootContainer.getInstance().getComponentInstanceOfType(
        LogService.class); 

    logService.setLogLevel("org.exoplatform.services.jcr", LogService.DEBUG, true);

    //servicesManager = PortalContainer.getInstance();
    PortalContainer servicesManager = RootContainer.getInstance().getPortalContainer("exo");

    if(System.getProperty("java.security.auth.login.config") == null)
      System.setProperty("java.security.auth.login.config", "src/resource/login.conf" );

    credentials_ = new SimpleCredentials("exo", "exo".toCharArray());

    RepositoryService repositoryService = (RepositoryService) servicesManager.getComponentInstanceOfType(
        RepositoryService.class);

    repository_ = repositoryService.getRepository();           

    if(!((RepositoryImpl) repository_).isWorkspaceInitialized("ws"));
      ((RepositoryImpl) repository_).initWorkspace("ws", "nt:unstructured");
  
    if(!((RepositoryImpl) repository_).isWorkspaceInitialized("ws2"));
      ((RepositoryImpl) repository_).initWorkspace("ws2", "nt:unstructured");

    session = (SessionImpl)repository_.login(credentials_, "ws");
    root = session.getRootNode();    
    
    orgService = (OrganizationService)servicesManager_.getComponentInstanceOfType(OrganizationService.class);    
    dialogService_ = (TemplateService) servicesManager_.getComponentInstanceOfType(TemplateService.class);    
  }

}
