/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.calendar.renderer.html;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;

/**
 * @email:   danny_xcz@users.sourceforge.net
 */
public class EventRenderer extends HtmlBasicRenderer {

	public final static String BACK_ACTION = "back";
	public final static String EDIT_ACTION = "edit";
	static Parameter[] BACK = { new Parameter(ACTION, BACK_ACTION)};
	static Parameter[] EDIT = { new Parameter(ACTION, EDIT_ACTION)};

	SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
	SimpleDateFormat timeFormat = new SimpleDateFormat("H:m");

	final public void encodeBegin(FacesContext context, UIComponent component)
		throws IOException {
		ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
		ResponseWriter w = context.getResponseWriter();
		//UICalendarEvent uiEvent = (UICalendarEvent) component;

		w.write("<table class='UICalendarEvent'>");
		w.write("<tr>");
		w.write("<th colspan='2'>");
		w.write(res.getString("UICalendarEvent.header.title"));
		w.write("</th>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.topic"));
		w.write("</td>");
		w.write("<td>");
		//w.write(uiEvent.getEvent().getSummary());
		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.location"));
		w.write("</td>");
		w.write("<td>");
		//w.write(uiEvent.getEvent().getLocation());
		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.startDate"));
		w.write("</td>");
		w.write("<td>");
		//w.write(dateFormat.format(uiEvent.getEvent().getDtStart().getTime()));
		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.startTime"));
		w.write("</td>");
		w.write("<td>");

		//w.write(timeFormat.format(uiEvent.getEvent().getDtStart().getTime()));

		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.endDate"));
		w.write("</td>");
		w.write("<td>");
		//w.write(dateFormat.format(uiEvent.getEvent().getDtEnd().getTime()));
		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.endTime"));
		w.write("</td>");
		w.write("<td>");
		//w.write(timeFormat.format(uiEvent.getEvent().getDtEnd().getTime()));
		w.write("</td>");
		w.write("</tr>");

//		w.write("<tr>");
//		w.write("<td>");
//		w.write(res.getString("UICalendarEvent.label.allDayEvent"));
//		w.write("</td>");
//		w.write("<td>");
//		w.write(uiEvent.getEvent().getAllDayEvent() ? "true" : "false");
//		w.write("</td>");
//		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.content"));
		w.write("</td>");
		w.write("<td>");
		//w.write(uiEvent.getEvent().getComment());
		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td>");
		w.write(res.getString("UICalendarEvent.label.category"));
		w.write("</td>");
		w.write("<td>");
		//w.write(uiEvent.getEvent().getCategories());
		w.write("</td>");
		w.write("</tr>");

		w.write("<tr>");
		w.write("<td colspan='2'>");
//		linkRenderer_.render(w, uiEvent, "#{UICalendarPortlet.button.edit}", EDIT);
//		linkRenderer_.render(w, uiEvent, "#{UICalendarPortlet.button.back}", BACK);
		w.write("</td>");
		w.write("</tr>");

		w.write("</table>");
	}

}