/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.forum.component;

import org.exoplatform.faces.core.component.UIIntegerInput;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.services.forum.Category;
import org.exoplatform.services.forum.ForumService;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UICategoryForm.java,v 1.7 2004/10/17 13:46:25 tuan08 Exp $
 */
public class UICategoryForm extends UISimpleForm {
  static String CATEGORY_NAME = "categoryName" , CATEGORY_DESC = "categoryDesc" ,
  CATEGORY_ORDER = "order";
    
  Category category_ ;
  
  public UICategoryForm(ForumService service) throws Exception {
    super("categoryForm", "post", null) ;
    setId("UICategoryForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    
    add(new UIStringInput(CATEGORY_NAME,"").addValidator(EmptyFieldValidator.class)) ;
    add(new UITextArea(CATEGORY_DESC,"").addValidator(EmptyFieldValidator.class)) ;
    add(new UIIntegerInput(CATEGORY_ORDER, 0)) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
  }
  
  public void setCategory(Category category) {
    category_ = category ;
    if (category == null) {
      reset() ;
    } else {
      getUIStringInput(CATEGORY_NAME).setValue(category.getCategoryName()) ;
      getUIStringInput(CATEGORY_DESC).setValue(category.getDescription()) ;
      getUIIntegerInput(CATEGORY_ORDER).setIntValue(category.getCategoryOrder()) ;
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UICategoryForm uiForm = (UICategoryForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIAdminViewCategories.class) ;
    }
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UICategoryForm uiForm = (UICategoryForm) event.getComponent() ;
      Category category = uiForm.category_ ;
      ForumService service = UIForumPortlet.getForumService() ;
      
      boolean isNew =  false ;
      if(category == null) {
        category = service.createCategoryInstance() ;
        isNew = true ;
      }
      category.setCategoryName(uiForm.getUIStringInput(CATEGORY_NAME).getValue()) ;
      category.setDescription(uiForm.getUIStringInput(CATEGORY_DESC).getValue()) ;
      category.setCategoryOrder(uiForm.getUIIntegerInput(CATEGORY_ORDER).getIntValue()) ;
      if(isNew) service.addCategory(category) ;
      else   service.updateCategory(category) ;
      UIAdminViewCategories uiCategories =
        (UIAdminViewCategories) uiForm.getSibling(UIAdminViewCategories.class) ;
      uiCategories.update() ;
      uiForm.setRenderedSibling(UIAdminViewCategories.class) ;
    }
  }
}