/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.portlet.PortletPreferences;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIAddURIForm extends UISimpleForm {
  static String NAME= "name", URI = "uri" ;
  
  public UIAddURIForm() {
    super("pmanagerForm", "post", null) ;
    setId("UIProjectManagerForm") ;
    setClazz("UIExoForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(URI, "")) ;
    add(new UIStringInput(NAME, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIAddURIForm uiForm = (UIAddURIForm) event.getComponent() ;
      PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
      String uri = uiForm.getUIStringInput(URI).getValue() ;
      String name = uiForm.getUIStringInput(NAME).getValue() ;
      prefs.setValue(uri, name) ;
      prefs.store() ;
      UIProjectManagers uicomp = 
        (UIProjectManagers) uiForm.getSibling(UIProjectManagers.class) ;
      uicomp.update() ;
      uiForm.setRenderedSibling(UIProjectManagers.class) ;
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIAddURIForm uiForm = (UIAddURIForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIProjectManagers.class);
		}
	}
}