/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.portlet.PortletPreferences;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.* ;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectManagerForm extends UISimpleForm {
  static String NAME= "name", URI = "uri", DESCRIPTION = "description" ;
  
  public UIProjectManagerForm() {
    super("pmanagerForm", "post", null) ;
    setId("UIProjectManagerForm") ;
    setClazz("UIExoForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(URI, "")) ;
    add(new UIStringInput(NAME, "")) ;
    add(new UIStringInput(DESCRIPTION, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerForm uiForm = (UIProjectManagerForm) event.getComponent() ;
      ProjectManagerService service = 
        (ProjectManagerService) PortalContainer.getComponent(ProjectManagerService.class) ;
      ProjectManagerConfig config = new ProjectManagerConfig() ;
      config.setPath(uiForm.getUIStringInput(URI).getValue()) ;
      config.setName(uiForm.getUIStringInput(NAME).getValue()) ;
      config.setDescription(uiForm.getUIStringInput(DESCRIPTION).getValue()) ;
      service.createProjectManager(config) ;
      PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
      String uri = config.getPath() + "/" + config.getName() ;
      prefs.setValue(uri, uri ) ;
      prefs.store() ;
      UIProjectManagers uicomp = 
        (UIProjectManagers) uiForm.getSibling(UIProjectManagers.class) ;
      uicomp.update() ;
      uiForm.setRenderedSibling(UIProjectManagers.class) ;
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerForm uiForm = (UIProjectManagerForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIProjectManagers.class);
		}
	}
}