/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.pmanager.ProjectUtil ;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectVersionForm extends UISimpleForm {
  static String VERSION_NUMBER= "versionNumber".intern(), 
                NAME= "name".intern(), DESCRIPTION = "description".intern() ;

  Project project_ ;
  Class backComponent_ ;
  
  public UIProjectVersionForm() {
    super("UIProjectVersionForm", "post", null) ;
    setId("UIProjectVersionForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(VERSION_NUMBER, "")) ;
    add(new UIStringInput(NAME, "")) ;
    add(new UITextArea(DESCRIPTION, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void setData(Project project, Class backComponent) {
    project_  = project ;
    backComponent_ = backComponent ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectVersionForm uiForm = (UIProjectVersionForm) event.getComponent() ;
      String versionNumber = uiForm.getUIStringInput(VERSION_NUMBER).getValue() ;
      String name = uiForm.getUIStringInput(NAME).getValue() ;
      String description = uiForm.getUIStringInput(DESCRIPTION).getValue() ;
      ProjectUtil.createVersion(uiForm.project_, versionNumber, name, description) ;
      uiForm.project_.save() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectVersionForm uiForm = (UIProjectVersionForm) event.getComponent() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
}