/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.util.List;
import javax.jcr.Node;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.services.pmanager.Constant;
import org.exoplatform.services.pmanager.Project;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UITaskForm extends UISimpleForm {
  static String NAME = "name".intern(), TODO = "todo".intern(),
         ASSIGNEE = "assignee".intern(), STATUS = "status".intern() ;
  private static List STATUS_OPTIONS = UIIssueForm.STATUS_OPTIONS ;
  
  Node issue_ ;
  Node task_ ;
  
  public UITaskForm() {
    super("UITaskForm", "post", null) ;
    setId("UITaskForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(NAME, "").
        addValidator(EmptyFieldValidator.class)) ;
    add(new UISelectBox(ASSIGNEE, "",null).setSize(3)) ;
    add(new UISelectBox(STATUS, "evaluate", STATUS_OPTIONS)) ;
    add(new UITextArea(TODO, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void addNewTask(Project project, Node issue) throws Exception {
    task_ = null ;
    issue_ = issue ;
    reset() ;
    List list = Util.createParticipantOptions(project) ;
    getUIStringInput(NAME).setEditable(true) ;
    getUISelectBox(ASSIGNEE).setOptions(list) ;
  }
  
  public void editTask(Project project, Node issue, String taskName) throws Exception {
    Node tasks = issue.getNode(Constant.ISSUE_TASKS) ;
    task_ =  tasks.getNode(taskName) ;
    issue_ = issue ;
    List list = Util.createParticipantOptions(project) ;
    getUISelectBox(ASSIGNEE).setOptions(list) ;
    getUIStringInput(NAME).setEditable(false) ;
    setFieldValue(NAME, task_.getName()) ;
    setFieldValue(ASSIGNEE, task_.getProperty(Constant.ISSUE_TASK_ASSIGNEE).getString()) ;
    setFieldValue(STATUS, task_.getProperty(Constant.ISSUE_TASK_STATUS).getString()) ;
    setFieldValue(TODO, task_.getProperty(Constant.ISSUE_TASK_TODO).getString()) ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UITaskForm uiForm = (UITaskForm) event.getComponent() ;
      Node node = uiForm.task_ ;
      if(node == null) {
        Node tasks = null ;
        if(uiForm.issue_.hasNode(Constant.ISSUE_TASKS)) {
          tasks = uiForm.issue_.getNode(Constant.ISSUE_TASKS) ;
        } else {
          tasks = uiForm.issue_.addNode(Constant.ISSUE_TASKS, Constant.CONTAINER_NODE_TYPE) ;
        }
        node = tasks.addNode(uiForm.getUIStringInput(NAME).getValue(), 
                             Constant.ISSUE_TASK_NODE_TYPE) ;
      }
      node.setProperty(Constant.ISSUE_TASK_ASSIGNEE, 
                       uiForm.getUISelectBox(ASSIGNEE).getValue()) ;
      node.setProperty(Constant.ISSUE_TASK_STATUS, 
                       uiForm.getUISelectBox(STATUS).getValue()) ;
      node.setProperty(Constant.ISSUE_TASK_TODO, 
                       uiForm.getUIStringInput(TODO).getValue()) ;
      uiForm.issue_.save() ;
      uiForm.setRenderedSibling(UIIssue.class);
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UITaskForm uiForm = (UITaskForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIIssue.class);
		}
	}
}