/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.forum.test;

import java.util.Date;
import java.util.List;

import org.exoplatform.commons.utils.PageList;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.forum.Category;
import org.exoplatform.services.forum.Forum;
import org.exoplatform.services.forum.ForumServiceContainer;
import org.exoplatform.services.forum.ForumServiceException;
import org.exoplatform.services.forum.Post;
import org.exoplatform.services.forum.Topic;
import org.exoplatform.services.forum.Watcher;
import org.exoplatform.services.forum.hibernate.WatcherNotifyListener;

/**
 * Created by The eXo Platform SARL Author : Tuan Nguyen
 * tuan08@users.sourceforge.net Dec 15, 2005
 */
public class TestQueueWatcherNotifyListener extends ForumServiceTestCase {  
  
  private WatcherNotifyListener watcherListener_ ;
  
  public TestQueueWatcherNotifyListener(String name) {
    super(name);
  }

  public void setUp() throws Exception {
    if (service_ == null) {
      PortalContainer manager = PortalContainer.getInstance();
      container_ = 
        (ForumServiceContainer) manager.getComponentInstanceOfType(ForumServiceContainer.class);
      service_ = container_.findForumService("exo");
    }
  }

  public void tearDown() throws Exception {    
  }

  public void testQueueWatcherNotifyListener() throws Exception {
    Category category = service_.createCategoryInstance() ;    
    category.setCategoryName("test") ;
    category.setDescription("test") ;  
    category = service_.addCategory(category) ;
    
    Forum forum = service_.createForumInstance() ; 
    forum.setForumName("testForum") ;
    forum.setDescription("testForum") ;
    forum = service_.addForum(category, forum) ;
    
    Watcher forumWatcher = service_.createWatcher(forum) ;
    forumWatcher.setUserName("guest") ;
    forumWatcher.setMessageProtocol("smtp") ;
    forumWatcher.setAddress("exo@PC01") ;
    service_.saveWatcher(forumWatcher) ;
    
    Topic topic = service_.createTopicInstance() ; 
    topic.setOwner("exo") ;
    topic.setModifiedBy("exo") ;
    topic.setTopic("testTopic") ;
    topic.setDescription("testTopic") ;
    topic = service_.addTopic(forum, topic) ;
    
    Watcher topicWatcher = service_.createWatcher(topic) ;
    topicWatcher.setUserName("exo") ;
    topicWatcher.setMessageProtocol("smtp") ;
    topicWatcher.setAddress("exo@PC01") ;
    service_.saveWatcher(topicWatcher) ;

    
    topicWatcher = service_.createWatcher(topic) ;
    topicWatcher.setUserName("guest") ;
    topicWatcher.setMessageProtocol("smtp") ;
    topicWatcher.setAddress("exo.platform@laposte.net") ;
    service_.saveWatcher(topicWatcher) ;
        
    Post post = service_.createPostInstance() ; 
    post.setOwner("exo") ;
    post.setModifiedBy("namph") ;
    post.setSubject("testPost") ;
    post.setMessage("testMessage") ;    
    post = service_.addPost(topic, post) ;
    //Sleep 1,5 second to JobschedulerService excecute QueueTaskJob
    System.out.println("please wait to send mail.....") ;
    Thread.sleep(3500) ;
    System.out.println("send mail complete") ;
    service_.removeCategory(category.getId()) ;
    service_.removeWatcher(forumWatcher) ;
    service_.removeWatcher(topicWatcher) ;
  }
  protected String getDescription() {
    return "Test Queue Wacher Notify Listener";
  }  
}
