/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager.impl;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.Repository;
import javax.jcr.Session;

import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.jcr.RepositoryService;
import org.exoplatform.services.jcr.impl.RepositoryContainer;
import org.exoplatform.services.jcr.impl.core.RepositoryImpl;
import org.exoplatform.services.jcr.index.JCRIndexerPlugin;
import org.exoplatform.services.pmanager.ProjectManager;
import org.exoplatform.services.pmanager.ProjectManagerConfig;
import org.exoplatform.services.pmanager.ProjectManagerService;
import org.exoplatform.services.pmanager.impl.exont.ProjectManagerType;
import org.exoplatform.services.pmanager.impl.exont.ProjectType;
import org.exoplatform.services.pmanager.impl.indexing.ExoIssueConverter;
/**
 * @author Tuan Nguyen
 */
public class ProjectManagerServiceImpl implements ProjectManagerService {
  
  private RepositoryService jcrService_ ;
/* 
  public ProjectManagerServiceImpl(RepositoryService jcrService, 
		  							InitParams params,
                                   JCRIndexerPlugin plugin) throws Exception {
    jcrService_ = jcrService ;
    Repository repository = jcrService.getRepository();
    RepositoryContainer container = ((RepositoryImpl)repository).getContainer();    
    container.registerComponentImplementation("exo:project", ProjectType.class);
    container.registerComponentImplementation("exo:projectManager", ProjectManagerType.class);
    
    List configs = params.getObjectParamValues(ProjectManagerConfig.class) ;
    for(int i = 0; i < configs.size(); i++ ) {
      ProjectManagerConfig config = (ProjectManagerConfig) configs.get(i) ;
      if(config.isAutocreated()) {
        createProjectManager(config) ;
      }
    }
    
    plugin.addNodeDataConverter(new ExoIssueConverter()) ;
  }
 
 */
  public ProjectManagerServiceImpl(RepositoryService jcrService, 
          InitParams params,
          JCRIndexerPlugin plugin) throws Exception {
	jcrService_ = jcrService ;
	Repository repository = jcrService.getRepository();
	RepositoryContainer container = ((RepositoryImpl)repository).getContainer();    
	container.registerComponentImplementation("exo:project", ProjectType.class);
	container.registerComponentImplementation("exo:projectManager", ProjectManagerType.class);
	
	List configs = params.getObjectParamValues(ProjectManagerConfig.class) ;
	for(int i = 0; i < configs.size(); i++ ) {
	ProjectManagerConfig config = (ProjectManagerConfig) configs.get(i) ;
	if(config.isAutocreated()) {
		createProjectManager(config) ;
	}
	}
	
	plugin.addNodeDataConverter(new ExoIssueConverter()) ;
  }
  
  public ProjectManager getProjectManager(String ws, String path) throws Exception {
    Repository repository = jcrService_.getRepository();
    Session session = repository.login() ;
    Node node = (Node)session.getItem(path) ;
    return new ProjectManager(node) ;
  }

  public List getProjectManagers(String ws, List paths) throws Exception {
    Repository repository = jcrService_.getRepository();
    Session session = repository.login() ;
    List list = new ArrayList() ;
    for(int i = 0; i < paths.size(); i++) {
      String path = (String) paths.get(i) ;
      Node node = (Node)session.getItem(path) ;
      list.add(new ProjectManager(node)) ;
    }
    return list ;
  }

  public ProjectManager createProjectManager(ProjectManagerConfig config) throws Exception {
    Repository repository = jcrService_.getRepository();
    Session session = repository.login(config.getWorkspace());
    Node root = session.getRootNode();
    String pmanagerPath = config.getPath() + "/" + config.getName() ;
    if(pmanagerPath.startsWith("/")) pmanagerPath = pmanagerPath.substring(1) ;
    if(root.hasNode(pmanagerPath)) {
      Node node = root.getNode(pmanagerPath) ;
      return new ProjectManager(node) ;
    } 
    //Node pmanagerNode = root.addNode(pmanagerPath, "exo:projectManager") ;
    Node pmanagerNode = root.addNode(pmanagerPath, "exo:projectManager") ;
    pmanagerNode.setProperty("exo:owner", config.getOwner());
    
    if(config.getDescription() != null) {
      pmanagerNode.setProperty("exo:description", config.getDescription());
    }
    root.save() ;
    return  new ProjectManager(pmanagerNode) ;
  }

}