/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager.impl.exont;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.*;
import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * @author Tuan Nguyen
 */
public class CommentType extends NodeTypeImpl {

  public CommentType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:comment";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[4];
    this.declaredPropertyDefinitions[0] = 
      new PropertyDefinitionImpl("exo:creator",                 //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          null,                        //defaultValues
                          false,                       //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false                        //multiple         
      );
    
    this.declaredPropertyDefinitions[1] = 
      new PropertyDefinitionImpl("exo:createdDate",          //name
                          this,                       //declaringNodeType
                          PropertyType.DATE,         //requiredType
                          null,                        //valueConstraints 
                          NULL_VALUES,                     //defaultValues
                          true,                       //autoCreate       
                          true,                        //mandatory
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false
      );
    
    this.declaredPropertyDefinitions[2] = 
      new PropertyDefinitionImpl("exo:modifiedDate",          //name
                          this,                        //declaringNodeType
                          PropertyType.DATE,           //requiredType
                          null,                        //valueConstraints 
                          NULL_VALUES,                 //defaultValues
                          true,                        //autoCreate       
                          true,                        //mandatory
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false
      );
    this.declaredPropertyDefinitions[3] = 
      new PropertyDefinitionImpl("exo:data",                  //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          NULL_VALUES,                 //defaultValues
                          true,                        //autoCreate       
                          true,                        //mandatory
                          OnParentVersionAction.COPY,  //onVersion        
                          false,                       //readOnly         
                          false
      );
    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }
}