/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.pmanager.impl.exont;


import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.*;
import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ResourceType.java 1681 2005-07-29 12:02:20Z benjmestrallet $
 */
public class ResourceType extends NodeTypeImpl {

  public ResourceType(NodeTypeManager manager) throws NoSuchNodeTypeException,RepositoryException {
    super(manager);
    this.name = "exo:resource";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[1];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,     //name
        this,                         //declaringNodeType
        PropertyType.UNDEFINED,       //requiredType     
        null,                         //valueConstraints 
        NULL_VALUES,                  //defaultValues
        false,                        //autoCreate       
        false,                        //mandatory        
        OnParentVersionAction.COPY,   //onVersion        
        false,                        //readOnly         
        false
        );

    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }

}
