/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.core.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Jan 3, 2006
 */
public class DataStream {  
  
  public synchronized byte[] load( String path) throws Exception {
    File file = new File( path);       
    return load( file );
  }
  
  public synchronized byte[] load( File file ) throws Exception {
    if ( ! file.exists() || !file.isFile()) file.createNewFile();        
    FileInputStream input = new FileInputStream(file);
    FileChannel fchan = input.getChannel();
    long fsize = fchan.size();       
    ByteBuffer buff = ByteBuffer.allocate((int)fsize);        
    fchan.read(buff);
    buff.rewind();      
    byte[] data = buff.array();      
    buff.clear();      
    fchan.close();        
    input.close();       
    return data;
  }
  
  public synchronized void save( String path, byte[] d ) throws Exception {
    File file = new File( path);
    save( file, d);
  }
  
  public synchronized void save( File file, byte[] d ) throws Exception {
    if( file.isDirectory()) return;   
    if (file.exists()) file.delete();         
    if (!file.exists()) file.createNewFile();       
    FileOutputStream fout = new FileOutputStream( file);
    FileChannel fchan = fout.getChannel();      
    ByteBuffer buff = ByteBuffer.allocateDirect( d.length);        
    for(int i=0; i<d.length; i++){
      buff.put(d[i]);
    }        
    buff.rewind();
    fchan.write(buff);        
    buff.clear();        
    fchan.close();
    fout.close();    
  }
  
}
