/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.htmlparser.impl;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.services.spider.core.htmlparser.Node;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Jan 3, 2006
 */
abstract class AbstractNode {
  
  protected Node parent;   
  
  protected List<Node> children;
  
  protected Token token;
  
  protected int type = -2;
  
  protected String name;
  
  protected boolean close = false ;
  
  AbstractNode( Token t){
    token = t;    
    splitName();
    children = new ArrayList<Node>();
  }
  
  private void splitName(){
    if( token.getType() == Token.CONTENT){
      type = -1;
      return;
    }
    name =  token.getValue();
    if( name.endsWith("/")){
      type = 0;
      return;
    }
    if( name.indexOf(" ") > -1)  name = name.substring(0, name.indexOf(" ")).toLowerCase();   
    String [] singleName = {
        "area","base","basefont","br","col","!doctype","frame","hr",
        "img","input","isindex","link","meta","param"
    };
    
    for( String ele : singleName){
      if( ele.equals( name)){
        type = 0;
        return;
      }
    }
    type = 1;
  }
  
  protected StringBuilder toValue(String tab){    
    StringBuilder value = new StringBuilder();
    value.append("\n");
    value.append( tab);
    if( type == -1) {
      value.append(" ");
      value.append( token.getValue());
      value.append(" ");
      return value;
    }        
    value.append( "<"); 
    value.append( token.getValue().trim());
    value.append(">");
    for( Node ele : children){     
      value.append( ((AbstractNode)ele).toValue(tab+" "));    
    }
    if( type == 1){      
      value.append("\n");
      value.append( tab);
      value.append( "</"); 
      value.append( name);
      value.append(">");
    }
    return value;
  }
  
  protected StringBuilder toValue(){    
    StringBuilder value = new StringBuilder();   
    if( type == -1) {
      value.append(" ");
      value.append( token.getValue());
      value.append(" ");
      return value;
    }        
    value.append( "<"); 
    value.append( token.getValue().trim());
    value.append(">");
    for( Node ele : children){     
      value.append( ((AbstractNode)ele).toValue());    
    }
    if( type == 1){
      value.append( "</"); 
      value.append( name);
      value.append(">");
    }
    return value;
  }
  
  public boolean isClose(){
    if (type != 1) return true;
    return close;
  }
  
  public void setClose(boolean v){
    close = v;
  }
  
  public Token getToken( ){
    return token;
  }
  
  public int getType(){
    return type;
  }
}
