/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.htmlparser.impl;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Dec 29, 2005
 */
abstract class AbstractNodeHandler { 
  
  String[] getAttributes( String token) {   
    if( token == null) return null;
    Pattern pattern = Pattern.compile(
        "\\b\\p{Space}*=\\p{Space}*", Pattern.CASE_INSENSITIVE);
    Matcher matcher = pattern.matcher( token);
    String text = matcher.replaceAll("=");    
    pattern = Pattern.compile("\\p{Space}+", Pattern.CASE_INSENSITIVE);    
    return pattern.split( text);
  }
  
  //get value attribute
  String getAttribute(String token, String attr) {    
    int i = findAttribute( token, attr);
    if( i < 0) return null;
    token = token.substring( i);
    if( token.charAt(0) == '\"') return cleanSign( token, "\"");
    if( token.charAt(0) == '\'') return cleanSign( token, "\'");
    String[] split = token.split(" ");
    if( split.length > 0) return split[0];
    return token;
  }
  //find order attribute
  int findAttribute(String token, String attr) {
    attr = attr.toLowerCase().trim();
    int i = -1;
    Pattern pattern = Pattern.compile(
        "\\b"+attr+"\\p{Space}*=\\p{Space}*", Pattern.CASE_INSENSITIVE);
    Matcher matcher = pattern.matcher( token);
    while( matcher.find()){
      i = matcher.end(0);
    }
    return i;
  }
    
  //clean value attribute
  String cleanSign( String line, String sign){
    if( !line.startsWith(sign))  {
      String [] split = line.split(" ");
      if( split.length > 0) return split[0];
      return line;
    }
    if(line.indexOf( sign, 1) > -1)
      return line.substring( 1, line.indexOf( sign, 1));
    String [] split = line.substring( 1, line.length()).trim().split(" ");
    if( split.length > 0) return split[0];
    return line;
  } 
}
