/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.htmlparser.impl;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.services.spider.core.htmlparser.Attribute;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Dec 29, 2005
 */
public class NodeHandler extends  AbstractNodeHandler {
  
  public Attribute getAttribute( Token token, String name) {
    return new AttributeImpl(name, getAttribute( token.getValue(), name));
  }  
  
  public String getAttributeValue( Token token, String name) {
    return  getAttribute( token.getValue(), name);
  }  
  
  public List<Attribute> getAttributes( Token token) {
    List<Attribute> list = new ArrayList<Attribute>();
    String [] split = getAttributes( token.getValue());
    for( String ele : split){
      if( ele.indexOf("=") > -1){
        String[] attrs = ele.split("="); 
        if( attrs[1].charAt(0) == '\"') attrs[1] = cleanSign( attrs[1], "\"");
        if( attrs[1].charAt( 0) == '\'') attrs[1] = cleanSign( attrs[1], "\'");
        list.add( new AttributeImpl( attrs[0], attrs[1]));
      }
    }      
    return list;
  }  
  
//  public void replaceAttribute(Token token, String attr) throws Exception {
//    if( token.getType() != TokenType.OPEN && token.getType() != TokenType.SINGLE) return;
//    token.setValue( "<"+token.getName()+" "+attr+">");
//  }  
//  
//  public void replaceAttribute( Token token, String attr, String v) throws Exception { 
//    if( token.getType() != TokenType.OPEN && token.getType() != TokenType.SINGLE) return;     
//    String origin = getAttribute( token.getValue(), attr);      
//    int start = findAttribute( token.getValue(), attr);      
//    StringBuilder string = new StringBuilder( token.getValue());
//    string = string.replace( start, start+origin.length()+1, "\""+v);
//    token.setValue( string.toString());    
//  }  
  
}
