/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl;

import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.datamodel.InternalQPath;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: Constants.java 3547 2006-01-03 08:42:56Z geaz $
 */

public class Constants {

  // default namespace (empty uri)
  public static final String NS_EMPTY_PREFIX = "";

  public static final String NS_DEFAULT_URI = "";

  // reserved namespace for exo node types
  public static final String NS_EXO_PREFIX = "exo";

  public static final String NS_EXO_URI = "http://www.exoplatform.com/jcr/exo/1.0";

  // reserved namespace for items defined by built-in node types
  public static final String NS_JCR_PREFIX = "jcr";

  public static final String NS_JCR_URI = "http://www.jcp.org/jcr/1.0";

  // reserved namespace for built-in primary node types
  public static final String NS_NT_PREFIX = "nt";

  public static final String NS_NT_URI = "http://www.jcp.org/jcr/nt/1.0";

  // reserved namespace for built-in mixin node types
  public static final String NS_MIX_PREFIX = "mix";

  public static final String NS_MIX_URI = "http://www.jcp.org/jcr/mix/1.0";

  // reserved namespace used in the system view XML serialization format
  public static final String NS_SV_PREFIX = "sv";

  public static final String NS_SV_URI = "http://www.jcp.org/jcr/sv/1.0";

  // reserved namespaces that must not be redefined and should not be used
  public static final String NS_XML_PREFIX = "xml";

  public static final String NS_XML_URI = "http://www.w3.org/XML/1998/namespace";

  public static final String NS_XMLNS_PREFIX = "xmlns";

  public static final String NS_XMLNS_URI = "http://www.w3.org/2000/xmlns/";
  

  /**
   * jcr:primaryType
   */
  public static final InternalQName JCR_PRIMARYTYPE = new InternalQName(NS_JCR_URI, "primaryType");

  /**
   * jcr:mixinTypes
   */
  public static final InternalQName JCR_MIXINTYPES = new InternalQName(NS_JCR_URI, "mixinTypes");
  
  /**
   * jcr:mixinTypes
   */
  public static final InternalQName JCR_UUID = new InternalQName(NS_JCR_URI, "uuid");
  
  
  /**
   * jcr:path
   */
  public static final InternalQName JCR_PATH = new InternalQName(NS_JCR_URI, "path");
  
  /**
   * jcr:versionHistory
   */
  public static final InternalQName JCR_VERSION_HISTORY = new InternalQName(NS_JCR_URI, "versionHistory");

  
  public static final InternalQName JCR_XMLTEXT = new InternalQName(NS_JCR_URI, "xmltext");


  /**
   * nt:base
   */
  public static final InternalQName NT_BASE = new InternalQName(NS_NT_URI, "base");

    /**
     * jcr:score
     */
  public static final InternalQName JCR_SCORE = new InternalQName(NS_JCR_URI, "score");
  
  public static final InternalQName MIX_REFERENCEABLE = new InternalQName(NS_MIX_URI, "referenceable");
  
  public static final InternalQName MIX_VERSIONABLE = new InternalQName(NS_MIX_URI, "versionable");

  public static final InternalQName NT_VERSION_HISTORY = new InternalQName(NS_NT_URI, "versionHistory");

  public static final InternalQName NT_VERSION = new InternalQName(NS_NT_URI, "version");
  

  
  public static final String ROOT_URI = "[]:1";

  public static final String PRIMARY_TYPE_URI = "[http://www.jcp.org/jcr/1.0]primaryType";

  public static final String MIXIN_TYPE_URI = "[http://www.jcp.org/jcr/1.0]mixinTypes";

  public static final String ACCESS_TYPE_URI = "[http://www.exoplatform.com/jcr/exo/1.0]accessControllable";

  public static final String NODE_OWNER_URI = "[http://www.exoplatform.com/jcr/exo/1.0]owner";

  public static final String NODE_PERM_URI = "[http://www.exoplatform.com/jcr/exo/1.0]permissions";
  
  public static final String JCR_VERSION_STORAGE_URI = "[]:1[http://www.jcp.org/jcr/1.0]system:1[http://www.jcp.org/jcr/1.0]versionStorage:1";

  public static final String JCR_SYSTEM_URI = "[]:1[http://www.jcp.org/jcr/1.0]system:1";

}