/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.exo;


import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.core.ExtendedPropertyType;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * Created by The eXo Platform SARL
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: AccessControllableType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class AccessControllableType extends NodeTypeImpl {

  public AccessControllableType(NodeTypeManager manager) throws NoSuchNodeTypeException,RepositoryException {
    super(manager);
    this.name = "exo:accessControllable";
    this.mixin = true; 
    this.orderableChild = false;

    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "exo:owner",                  //name
        this,                         //declaringNodeType
        PropertyType.STRING,          //requiredType
        null,                         //valueConstraints 
        null,                         //defaultValues
        false,                        //autoCreate
        true,                         //mandatory
        OnParentVersionAction.COPY,   //onVersion        
        true,                         //readOnly
        false                         //multiple
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "exo:permissions",               // name
        this,                            //declaringNodeType
        ExtendedPropertyType.PERMISSION, //requiredType
        null,                            //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate
        true,                            //mandatory
        OnParentVersionAction.COPY,      //onVersion        
        true,                            //readOnly
        true                             //multiple
        );
  }

}
