/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.mix;


import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeDefinition;


import javax.jcr.PropertyType;
import javax.jcr.Value;


import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.nt.BaseType;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.RepositoryException;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ReferenceableType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class ReferenceableType extends NodeTypeImpl {

  public ReferenceableType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "mix:referenceable";
    this.mixin = true;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredPropertyDefinitions = new PropertyDefinition[1];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:uuid",                        //name              
        this,                              //declaringNodeType
        PropertyType.STRING,               //requiredType     
        EMPTY_CONSTRAINTS,                              //valueConstraints 
        null,                       //defaultValues    
        true,                              //autoCreate       
        true,                              //mandatory        
        OnParentVersionAction.INITIALIZE,  //onVersion        
        true,                              //readOnly         
        false                              //multiple         
        );

  }

}

