/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.PropertyType;
import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import javax.jcr.nodetype.*;
import javax.jcr.RepositoryException;

/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 31 juil. 2004
 */
public class QueryType extends NodeTypeImpl {

  public QueryType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:query";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:statement",                  //name
        this,                            //declaringNodeType
        PropertyType.STRING,             //requiredType     
        EMPTY_CONSTRAINTS,               //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate       
        false,                           //mandatory        
        OnParentVersionAction.COPY,      //onVersion        
        false,                           //readOnly         
        false                            //multiple         
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:language",                  //name
        this,                            //declaringNodeType
        PropertyType.STRING,             //requiredType     
        EMPTY_CONSTRAINTS,               //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate       
        false,                           //mandatory        
        OnParentVersionAction.COPY,      //onVersion        
        false,                           //readOnly         
        false                            //multiple         
        );

  }
}
