/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL                               *
 * All rights reserved.                                                    *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.importing;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
//import org.apache.commons.digester.Digester;
import java.util.Stack;
/**
 * Created by The eXo Platform SARL
 *  Used as rule vor sv:node element in org.apache.commons.digester
 *  on import repository content from System view (JSR-170 7.3.1)
 *
 * @author <a href="mailto:alex.kravchuk@gmail.com">Alexander Kravchuk</a>
 * @version $Id: SysViewNodeRule.java 3510 2005-12-29 17:32:57Z geaz $
 */
public class SysViewNodeRule extends CommonSysViewRule{


//    private Stack nodesStack;
//
//    protected Stack getNodesStack(){
//        return nodesStack;
//    }
//
//    SysViewNodeRule(Stack nodesStack){
//        if (nodesStack == null)
//            throw new NullPointerException("nodesStack can't be null");
//        this.nodesStack =nodesStack;
//    }


    SysViewNodeRule(Stack nodesStack){
        super(nodesStack);
    }


    /**
     * @todo check if node is parent of current context
     */
    public void begin(String namespace, String name, Attributes attributes)
          throws Exception {
      super.begin(namespace, name, attributes);
      digester.push( newElementDefinition(namespace,name,
                                          attributes,javax.jcr.Node.class));
  }



  public void body(String namespace, String name, String text)
          throws Exception {
      super.body(namespace, name, text);

      checkCurrentElementDefinition(namespace, name, javax.jcr.Node.class);
      if (!"".equals(text)){
          String errorText = "sv:node can't contain text body [" + text + "]. " +
                             "Node dump [" + peekElementDef().toString() + "]";

          log.error(errorText);
          throw new SAXException(errorText);
      }
  }

  public void end(String namespace, String name) throws Exception {
     super.end(namespace, name);

    checkCurrentElementDefinition(namespace, name, javax.jcr.Node.class);

    if (! peekElementDef().isProceed()){
         String errorText = "Node not created. Seems primaryType Not Found ."+
                            " Node ["+digester.peek().toString()+"]";
         log.error(errorText);
         throw new SAXException(errorText);
     }

//     javax.jcr.Node node = (javax.jcr.Node) nodesStack.pop();
     javax.jcr.Node node = popNode();

     log.debug("Pop node name["+node.getName()+"] path["+node.getPath()+"]");

     digester.pop();
  }

}
