/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.api.writing;


import javax.jcr.Node;
import javax.jcr.PropertyIterator;
import javax.jcr.ReferentialIntegrityException;
import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.JcrAPIBaseTest;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TestNodeReference.java 3510 2005-12-29 17:32:57Z geaz $
 */
public class TestNodeReference extends JcrAPIBaseTest {

  public void testGetReferences() throws RepositoryException {

    Node root = session.getRootNode();

    Node testNode = root.addNode("testGetReferences", "nt:unstructured");
    
    Node testNode1 = root.addNode("testGetReferences1", "nt:unstructured");

    
    testNode.addMixin("mix:referenceable");
    testNode1.addMixin("mix:referenceable");


    // Should be saved first
    root.save();

    Node n1 = root.addNode("n1", "nt:unstructured");
    Node n2 = root.addNode("n2", "nt:unstructured");
    Node n11 = root.addNode("n11", "nt:unstructured");

    n1.setProperty("p1", testNode);
    n2.setProperty("p1", testNode);
    n11.setProperty("p1", testNode1);

    root.save();

    PropertyIterator refs = testNode.getReferences();
    while(refs.hasNext())
    	log.debug("ref >>>"+refs.nextProperty());
    
    assertEquals(2, testNode.getReferences().getSize());
    assertEquals(1, testNode1.getReferences().getSize());
    
    testNode.remove();
    
    try {
      testNode.save();
      fail("ReferentialIntegrityException");
    } catch (ReferentialIntegrityException e) {
    } 
  }

}
