/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.cache.impl;

import org.exoplatform.services.cache.CacheService;
import org.exoplatform.services.remote.group.Message;
import org.exoplatform.services.remote.group.MessageHandler;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Mar 5, 2005
 * @version $Id$
 */
public class SynchronizeCacheMessageHandler extends MessageHandler  {
  final static public String IDENTIFIER =  "SynchronizeCacheMessageHandler" ;
  
  private CacheService cacheService_ ;
  
  public SynchronizeCacheMessageHandler(CacheService cacheService) { 
    super(IDENTIFIER) ;
    cacheService_ = cacheService ;
  }
  
  public Object handle(Message message) throws Exception {
    SynchronizeCacheMessage syncMessage = (SynchronizeCacheMessage) message.getMessage() ;
    DistributedExoCache cache = 
      (DistributedExoCache)cacheService_.getCacheInstance(syncMessage.getCacheName()) ;
    cacheService_.synchronize(syncMessage.getCacheName(), syncMessage.getCacheKey(), syncMessage.getCacheValue()) ;
    return null ;
  }
}
