/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.database;

import org.exoplatform.container.configuration.ConfigurationException;


/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: $
 * 
 * Entry point to hibernate service. Stores all hibernate configuration 
 * (one per database) 
 */

public interface HibernateConfigurationsService {
	
	/**
	 * @param name - name of hibernate configuration, i.e.
	 * component->init-params->property-param->name
	 * @return configuration
	 */
	HibernateConfiguration getHibernateConfiguration(String name) throws ConfigurationException;
	
	/**
	 * @return configuration for name==default-portal-configuration
	 * 
	 */
	HibernateConfiguration getDefaultPortalConfiguration() throws ConfigurationException;
	
	/**
	 * Closes all HibernateServices' sessions in a case if not closed
	 * by application 
	 */
	void closeAllSessions();
}