/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization;

import java.util.Collection;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Oct 13, 2005
 */
public interface GroupHandler {
  public Group createGroupInstance();
  public void createGroup(Group group, boolean broadcast) throws Exception ;
  public void addChild(Group parent, Group child, boolean broadcast) throws Exception;
  public void saveGroup(Group group, boolean broadcast) throws Exception ;
  public Group removeGroup(Group group, boolean broadcast) throws Exception ;
  public Collection findGroupByMembership(String userName, String membershipType) throws Exception ;
  public Group findGroupById(String groupId) throws Exception ;
  public Collection findGroups(Group parent) throws Exception ;
  public Collection findGroupsOfUser(String user) throws Exception ;
  public Collection getAllGroups() throws Exception;
  
  
  public void addGroupEventListener(GroupEventListener listener) ; 
}
