/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchForm.java,v 1.4 2004/09/29 17:44:51 benjmestrallet Exp $
 */
public class UISearchForm extends UISimpleForm {
  UIStringInput owner_ ;
  UIStringInput   viewPermission_ ;
  UIStringInput   editPermission_ ;
  static final private String SEARCH_ACTION = "searchPages" ;
  public UISearchForm() {
    super("searchForm", "post", null) ;
    setId("UISearchForm");
    setClazz("UITableForm") ;
    setRendererType("SimpleFormVelocityRenderer") ; 
    owner_ = new UIStringInput("owner", "") ;
    viewPermission_ = new UIStringInput("viewPermission","") ;
    editPermission_ = new UIStringInput("editPermission","") ;
    add(owner_);
    add(viewPermission_);
    add(editPermission_);
    addActionListener(SearchPagesActionListener.class, "searchPages") ;
  }
  public String getSearchAction(){return SEARCH_ACTION ; } 
  
  public String getOwner() { return owner_.getValue() ;}
  public void   setOwner(String owner) { owner_.setValue(owner) ;}
  
  public String getViewPermission() { return viewPermission_.getValue() ;}
  public void   setViewPermission(String s) { viewPermission_.setValue(s) ;}
  
  public String getEditPermission() { return editPermission_.getValue() ;}
  public void   setEditPermission(String s) { editPermission_.setValue(s) ;}
  
  static public class SearchPagesActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception { 
		  UISearchForm uiForm = (UISearchForm) event.getSource() ;
		  UIPageList uiList = (UIPageList) uiForm.getParent();
      uiList.queryDescriptions(uiForm.owner_.getValue(), 
                               uiForm.viewPermission_.getValue(),
                               uiForm.editPermission_.getValue()) ;
		}	
  }
 
}