/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component;

import javax.management.MBeanConstructorInfo;
import javax.management.MBeanInfo;import javax.management.MBeanOperationInfo;
import javax.management.MBeanParameterInfo;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIMBean.java,v 1.3 2004/08/01 18:56:11 tuan08 Exp $
 */
public class UIStandardViewMBean extends UIExoCommand {
  static public String EXECUTE_ACTION = "execute" ;
  static Parameter[] executeParams = {new Parameter(ACTION , EXECUTE_ACTION) };
  
	private MBeanInfo minfo_ ;
  private ObjectName name_ ;
  private MBeanServer mserver_ ;
  
	public UIStandardViewMBean() {
		setRendererType("VelocityRenderer") ;
    addActionListener(ExecuteActionListener.class, EXECUTE_ACTION) ;
	}
  
  public Parameter[] getExecuteParams()  { return executeParams ; }
  
  public ObjectName getObjectName() { return name_ ; }
  
  public MBeanServer getMBeanServer() { return mserver_ ; }
  
  public MBeanInfo getMBeanInfo() { return minfo_ ; }
  
  public void  setData(MBeanServer server, ObjectName name) throws Exception {
    mserver_ = server ;
    name_ = name ;
    minfo_ = mserver_.getMBeanInfo(name); 
  }
  
  public boolean canExecute( MBeanOperationInfo method) {
     MBeanParameterInfo[] param =  method.getSignature() ;
     for(int i = 0 ; i < param.length; i++) {
     	if(param[i].getType().equals("java.lang.String") ||
         param[i].getType().equals("java.lang.Boolean") ||
         param[i].getType().equals("java.lang.Double") ||
         param[i].getType().equals("java.lang.Float") ||
         param[i].getType().equals("java.lang.Long") ||
         param[i].getType().equals("java.lang.Integer") ||
         param[i].getType().equals(Boolean.TYPE.getName()) ||
         param[i].getType().equals(Double.TYPE.getName()) ||
         param[i].getType().equals(Float.TYPE.getName()) ||
         param[i].getType().equals(Long.TYPE.getName()) ||
         param[i].getType().equals(Integer.TYPE.getName())) {
        continue ; 
      }
      return false ; 
     }
    return true ; 
  }
  
  public String getDependencies(MBeanInfo minfo) {
    if(!minfo.getClassName().startsWith("exo")) return "" ;
    StringBuffer b = new StringBuffer() ;
    MBeanConstructorInfo[] constructors = minfo.getConstructors() ;
    MBeanConstructorInfo constructor = null ;
    for(int i = 0; i < constructors.length; i++) {
      if(constructor == null) constructor = constructors[i] ;
      if(constructor.getSignature().length < constructors[i].getSignature().length) {
        constructor = constructors[i] ;
      }
    }
    if(constructor == null) return "" ;
    MBeanParameterInfo[] params = constructor.getSignature() ;
    for(int i = 0 ; i < params.length; i++) {
      b.append(params[i].getType()).append(" ") ;
    }
    return b.toString() ;
  }
  
  static public class ExecuteActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIStandardViewMBean uiMBean = (UIStandardViewMBean)event.getComponent() ;
      int methodId = Integer.parseInt(event.getParameter(OBJECTID)) ;
      MBeanOperationInfo[] method = uiMBean.minfo_.getOperations();
      for (int i = 0; i < method.length; i++) {
        if(methodId == method[i].hashCode()) {
          UIDetail uiDetail = (UIDetail) uiMBean.getAncestorOfType(UIDetail.class) ;
          UIOperation uiOperation = 
            (UIOperation) uiDetail.getChildComponentOfType(UIOperation.class) ;
          uiOperation.setOperation(uiMBean.mserver_, uiMBean.name_, method[i]) ;
          uiDetail.setRenderedComponent(UIOperation.class) ;
          return ;
        }
      }
    }
  }
}