/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component.model;

import java.util.* ;
import javax.management.*;
/**
 * Jul 29, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: MBeanDomain.java,v 1.1 2004/07/31 14:56:21 tuan08 Exp $
 */
public class MBeanCategory {
  private String category_ ;
  private String label_ ;
  private List mbeans_ ;
  private boolean select_ ;
 
	public MBeanCategory(String name) {
    mbeans_ = new ArrayList() ;
    category_ = name ;
    int idx = name.lastIndexOf(':') ;
    if(idx > 0) label_ = name.substring(0, idx) ;
    else label_ = name ;
  }
  
  public String getCategory() { return category_ ; }
  
  public String getLabel() { return label_ ; }
  
  public List getMBeanDescriptions() { return mbeans_  ;}  
  
  
  public boolean isSelect() { return select_ ; }
  public void    setSelect(boolean b) { select_ = b ; }
  
  public void addObjectName(ObjectName oname) {
    mbeans_.add(new MBeanDescription(oname)) ;
  }
  
  public ObjectName findMBeanObjectname(String id) {
    for(int i = 0; i < mbeans_.size(); i++) {
      MBeanDescription desc = (MBeanDescription) mbeans_.get(i) ;
      if(id.equals(desc.getId())) return desc.getObjectName() ;
    }
    return null ; 
  }
  
  public MBeanDescription findMBeanDescription(String id) {
    for(int i = 0; i < mbeans_.size(); i++) {
      MBeanDescription desc = (MBeanDescription) mbeans_.get(i) ;
      if(id.equals(desc.getId())) return desc ;
    }
    return null ; 
  }
}