/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.unit;

import org.exoplatform.test.web.ExoWebClient;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import com.meterware.httpunit.WebResponse;
import com.meterware.httpunit.WebTable;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: CurrentResponseUnit.java,v 1.1 2004/10/11 23:36:06 tuan08 Exp $
 **/
public class HtmlPrintUnit extends WebUnit {
  
  public HtmlPrintUnit(String name, String description) {
    super(name, description) ;
  }
  
  
  public WebResponse execute(WebResponse previousResponse, WebTable block, 
                             ExoWebClient client) throws Exception {
    Document doc = previousResponse.getDOM() ;
    Node nodeToPrint = doc.getElementsByTagName("html").item(0) ;
    if(getBlockId() != null) {
      nodeToPrint =  getNodeById(nodeToPrint, getBlockId()) ;
    } 
    StringBuilder b = new StringBuilder() ;
    printNode(b, nodeToPrint, "") ;
    System.out.println(b.toString()) ;
    return previousResponse ;
  }
  
  private void printNode(StringBuilder b, Node node, String indent) throws Exception {
    if(node.getNodeType() == Node.TEXT_NODE) {
      b.append("\n").append(indent).append(((Text)node).getData());
    } else {
      b.append("\n") ;
      String nextIndentLevel = "  " + indent ;
      b.append(indent).append("<" ).append(node.getNodeName()).append(">") ;
      NodeList nodes = node.getChildNodes() ;
      for(int i = 0; i < nodes.getLength(); i++) {
        Node child =  nodes.item(i) ;
        printNode(b, child, nextIndentLevel) ; 
      }
      b.append("\n") ;
      b.append(indent).append("</" ).append(node.getNodeName()).append(">") ;
    }
  }
  
  private Node  getNodeById(Node node, String id) throws Exception {
    NamedNodeMap attrs = node.getAttributes() ;
    Node idNode = attrs.getNamedItem("id") ;
    if(idNode != null) {
      Attr attr = (Attr) idNode ;
      if(id.equals(attr.getValue())) {
        return node ;
      }
    }
    NodeList nodes = node.getChildNodes() ;
    for(int i = 0; i < nodes.getLength(); i++) {
      Node child =  nodes.item(i) ;
      Node foundNode = getNodeById(child, id) ;
      if(foundNode != null)  return foundNode ;
      
    }
    return null ;
  }
  public String getActionDescription() { 
    return "This web unit allow  you to print out the entire  return html  or a block of  html according to the id"; 
  }
}