/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.admin;

import condition.* ;
import suites.share.UserLoginSuite;
import suites.share.UserLogoutSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Nov 15, 2005
 */
public class IndexingPortletAdminSuite extends WebUnitSuite {
  static String DESC = "Go to JMX Monitoring page and test all the basic actions at the group tab" ;
  static String NAME = "IndexingPortletAdminSuite" ;
  
  public IndexingPortletAdminSuite() {    
    super(NAME, DESC) ;
    init("/Site Map/Indexing") ;
  }  
  public IndexingPortletAdminSuite(String path) {
    super(NAME, DESC) ;
    init(path) ;
  }  
  public void  init(path) {    
		goToPage(path) ;
    addWebUnit(
      new ClickURLLinkUnit("AddUpdateDeleteIndex", "Click on more link").
      setURL("&uicomponent=UIListIndexer&op=more&objectId=FileIndexerPlugin").      
      addValidator(new ExpectFormIdValidator("fileIndexerPlugin"))
    ) ;
		//Index invalid directory
    addWebUnit(
      new SubmitFormUnit("IndexInvalidDirectory", "Click on index link").
      setFormId("fileIndexerPlugin").      
      setField("directory", "invalidDirectory").      
      setField("op", "index").
      addValidator(new ExpectTextValidator("is not a valid directory."))
    ) ;
    //Reindex invalid directory
    addWebUnit(
      new SubmitFormUnit("ReindexInvalidDirectory", "Click on reindex link").
      setFormId("fileIndexerPlugin").      
      setField("directory", "invalidDirectory").      
      setField("op", "reindex").
      addValidator(new ExpectTextValidator("is not a valid directory."))
    ) ;    
    //Index valid directory
    addWebUnit(
      new SubmitFormUnit("ReindexInvalidDirectory", "Click on reindex link").
      setFormId("fileIndexerPlugin").      
      setField("directory", "../webapps/portal").      
      setField("op", "index").
      addValidator(new ExpectNoTextValidator("is not a valid directory."))
    ) ;
    //Reindex valid directory
    addWebUnit(
      new SubmitFormUnit("IndexInvalidDirectory", "Click on index link").
      setFormId("fileIndexerPlugin").      
      setField("directory", "../webapps/portal").      
      setField("op", "index").
      addValidator(new ExpectNoTextValidator("is not a valid directory."))
    ) ;
    //Back
    addWebUnit(
      new SubmitFormUnit("ClickOnCancel", "Click on cancel button").
      setFormId("fileIndexerPlugin").
      setField("op", "PhaseId[1].cancel").            
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIListIndexer&op=more&objectId=FileIndexerPlugin"))
    ) ;       
  }      
  public java.util.List getRequiredSuites() { 
  	String[] roles = ["user", "admin"] ;
   	return [new UserLoginSuite("admin", "exo", roles)] ;
  }
  
}