/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class AdminTheECMSuite extends WebUnitSuite {
  static String DESC = "Go to Admin The ECM page and test all the basic actions" ;
  static String NAME = "AdminTheECMSuite" ;
  
  public AdminTheECMSuite() {    
    super(NAME, DESC) ;
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTheECM", "Select Admin The ECM tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=ecm").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageTemplates"))      
    ) ;      
    //Manage Template  
    addWebUnit(
      new ClickURLLinkUnit("ManageTemplates", "Click on Manage Templates button").
      setURL("&uicomponent=UIECMAdminSummary&op=manageTemplates").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UITemplatesToolbar&op=addNodeType"))      
    ) ;
    //-----Back to Admin The ECM
    addWebUnit(
      new ClickURLLinkUnit("Back", "Click on Manage Templates button").
      setURL("&uicomponent=UITemplatesToolbar&op=PhaseId[1].cancel").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageScripts"))      
    ) ;    
    //Manage Scripts
    addWebUnit(
      new ClickURLLinkUnit("ManageScripts", "Click on Manage Scripts button").
      setURL("&uicomponent=UIECMAdminSummary&op=manageScripts").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=ScriptToolbar&op=add"))      
    ) ;    
    //-----Add New Script
    addWebUnit(
      new ClickURLLinkUnit("AddNewScript", "Click on Add button").
      setURL("&uicomponent=ScriptToolbar&op=add").                  
      addValidator(new ExpectFormIdValidator("scriptForm"))      
    ) ;    
    //-----Save New Script
    addWebUnit(
      new SubmitFormUnit("SaveNewScript", "Click on save link").
      setFormId("scriptForm").
      setField("content","script-content-test").                  
      setField("script","script-test").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIScriptList&op=edit&objectId=script-test"))           
    ) ;    
    //----------Edit Created Script
    addWebUnit(
      new ClickURLLinkUnit("EditScript", "Click on edit button").
      setURL("&uicomponent=UIScriptList&op=edit&objectId=script-test").                  
      addValidator(new ExpectFormIdValidator("scriptForm"))      
    ) ;    
    //----------Save Edited Script
    addWebUnit(
      new SubmitFormUnit("SaveEditedScript", "Click on save link").
      setFormId("scriptForm").
      setField("content","script-content-test-edited").                  
      setField("script","script-test").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIScriptList&op=delete&objectId=script-test"))           
    ) ;    
    //----------Delete Created Script
    addWebUnit(
      new ClickURLLinkUnit("DeleteNewScript", "Click on Delete button").
      setURL("&uicomponent=UIScriptList&op=delete&objectId=script-test").                  
      addValidator(new ExpectNoTextValidator("script-test"))      
    ) ;
    //-----Back to Admin The ECM
    addWebUnit(
      new ClickURLLinkUnit("Back", "Click on Manage Templates button").
      setURL("&uicomponent=ScriptToolbar&op=PhaseId[1].cancel").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageRules"))      
    ) ;
    
    //Manage Rules
    addWebUnit(
      new ClickURLLinkUnit("ManageRules", "Click on Manage Rules button").
      setURL("&uicomponent=UIECMAdminSummary&op=manageRules").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=RuleToolbar&op=add"))      
    ) ;    
    //-----Add New Rules
    addWebUnit(
      new ClickURLLinkUnit("AddNewRules", "Click on Add button").
      setURL("&uicomponent=RuleToolbar&op=add").                  
      addValidator(new ExpectFormIdValidator("RuleForm"))      
    ) ;        
    //-----Save New Rules
    addWebUnit(
      new SubmitFormUnit("SaveNewRules", "Click on save link").
      setFormId("RuleForm").
      setField("content","rule-content-test").                  
      setField("rule","rule-test").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIRuleList&op=edit&objectId=rule-test"))           
    ) ;        
    //----------Edit Created Rules
    addWebUnit(
      new ClickURLLinkUnit("EditRules", "Click on edit button").
      setURL("&uicomponent=UIRuleList&op=edit&objectId=rule-test").                  
      addValidator(new ExpectFormIdValidator("RuleForm"))      
    ) ;    
    //----------Save Edited Rules
    addWebUnit(
      new SubmitFormUnit("SaveEditedRule", "Click on save link").
      setFormId("RuleForm").
      setField("content","rule-content-test-edited").                  
      setField("rule","rule-test").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIRuleList&op=delete&objectId=rule-test"))           
    ) ;    
    //----------Delete Created Rules
    addWebUnit(
      new ClickURLLinkUnit("DeleteNewRule", "Click on Delete button").
      setURL("&uicomponent=UIRuleList&op=delete&objectId=rule-test").                  
      addValidator(new ExpectNoTextValidator("rule-test"))      
    ) ;
    //-----Back to Admin The ECM
    addWebUnit(
      new ClickURLLinkUnit("Back", "Click on Manage Templates button").
      setURL("&uicomponent=RuleToolbar&op=PhaseId[1].cancel").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=createActionType"))      
    ) ;
        
    //Create an Action Type
    addWebUnit(
      new ClickURLLinkUnit("CreateActionType", "Click on Create Action Type button").
      setURL("&uicomponent=UIECMAdminSummary&op=createActionType").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=add"))      
    ) ;
    //-----Back to Admin The ECM
    addWebUnit(
      new ClickURLLinkUnit("Back", "Click on Manage Templates button").
      setURL("&uicomponent=MainToolbar&op=PhaseId[1].cancel").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageTemplates"))      
    ) ;
  }     
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite("admin", "exo", roles)] ;
  }  
}