/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package suites.share ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.* ;
import org.exoplatform.test.web.validator.*;
/**  
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: CommonUnit.java,v 1.2 2004/10/21 15:21:49 tuan08 Exp $
 **/
public class CommonUnit extends WebUnitSuite {
  
  final static public WebUnit GO_HOME_UNIT = 
    new ClickLinkWithText("GoToHome", "Tell the web client click on the Home page").
    setTextLink("Home") ; 
    
  final static public WebUnit CLICK_VIEW_MODE = 
  	new ClickURLLinkUnit("ClickViewMode", "Tell the web client click on the view Mode link").
    setURL("op=changeMode&mode=normal").    
    addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbarView&op=changeMode&mode=edit-navigation")) ;    
  final static public WebUnit CLICK_EDIT_NAVIGATION_MODE = 
  	new ClickURLLinkUnit("ClickEditNavigationMode", "Tell the web client click on the Edit Navigation Mode link").
    setURL("uicomponent=UIToolbarView&op=changeMode&mode=edit-navigation").
	  addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbarNav&op=saveNode")) ; 
    
  final static public WebUnit CLICK_EDIT_PAGE_MODE = 
  	new ClickURLLinkUnit("ClickEditPageMode", "Tell the web client click on the Edit Page Mode link").
    setURL("UIToolbarView&op=changeMode&mode=edit-page").
	  addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbarPage&op=savePage")) ;   
  
  final static public WebUnit CLICK_EDIT_PORTAL_MODE = 
    new ClickURLLinkUnit("ClickEditPortalModeButton", "Tell web client click on Edit Portal Mode").
    setURL("op=changeMode&mode=edit-portal").
    addValidator(new ExpectLinkWithURLValidator("componentId=portal-edit-mode&portal:action=editProperty"))        
  
  final static public WebUnit CLICK_BROWSE_PAGES =
    new ClickURLLinkUnit("ClickBrowsePages", "Tell web client click 'BrowsePages' on a page").
    setURL("uicomponent=UIToolbarPage&op=browsePage").
    addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbar&op=newPage"));
    
  final static public WebUnit CLICK_BROWSE_NAV =
    new ClickURLLinkUnit("ClickBrowsePages", "Tell web client click 'BrowsePages' on a page").
    setURL("uicomponent=UIToolbarNav&op=browsePage").
    addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbar&op=newPage"));

  static public void addClickUnits(WebUnitSuite suite , String path) {
    String[] links = path.split("/") ;
    for(text  in  links) {
      suite.addWebUnit(new ClickLinkWithText("Click:" + text, "Go to " + text + "page").
                      setTextLink(text)) ;
    }
  }
}
