alias ls="ls --color"

alias cdhome="cd ~"
alias cdwinhome="cd $USER_HOME"
alias cdback='cd  $OLDPWD'
alias cdv2x="cd $EXO_SRC_CODE"
alias cdexo-platform="cd $EXO_SRC_CODE/exo-platform"
alias cdexo-portal="cd $EXO_SRC_CODE/exo-portal"
alias cdexo-ecm="cd $EXO_SRC_CODE/exo-ecm"
alias cdexo-assembly="cd $EXO_SRC_CODE/exo-assembly"
alias cdexo-test="cd $EXO_SRC_CODE/exo-test"
alias cdbasedir="cd $BASE_DIRECTORY"
alias cdtomcat="cd $EXO_WORKING_DIR/exo-tomcat"
alias cdtomcatbin="cd $EXO_WORKING_DIR/exo-tomcat/bin"

#this alias command will create  new clean tomcat environment
alias mvntomcatnew="cd $EXO_SRC_CODE/exo-assembly/portal && 
                    mvn exo:platform -Ddeploy=newTomcat && 
                    cdback"

#this alias command will copy  all the exo portal modules to the tomcat
alias mvntomcatdeployportal="cd $EXO_SRC_CODE/exo-assembly/portal && 
                             mvn exo:platform -Ddeploy=tomcat && 
                             cdback"

#this alias command will copy  all the exo portal modules to the tomcat
alias mvntomcatdeploycms="cd $EXO_SRC_CODE/exo-assembly/cms && 
                          mvn exo:platform -Ddeploy=tomcat && 
                          cdback"

alias mvnmodulecleaninstall="mvn clean install"
alias mvnmoduledeploy="mvn clean install exo:module -Ddeploy=nodep"
alias mvnmoduledeployall="mvn clean install exo:module -Ddeploy=all"

alias mvncleanexo-platform="cd $EXO_SRC_CODE/exo-platform && mvn clean"
alias mvncleanexo-portal="cd $EXO_SRC_CODE/exo-portal && mvn clean"
alias mvncleanexo-jcr="cd $EXO_SRC_CODE/exo-jcr && mvn clean"
alias mvncleanexo-ecm="cd $EXO_SRC_CODE/exo-ecm && mvn clean"
alias mvncleanportal="mvncleanexo-platform && mvncleanexo-portal"
alias mvncleanecm="mvncleanportal && mvncleanexo-jcr && mvncleanexo-ecm"


alias mvnbuildexo-platform="cd $EXO_SRC_CODE/exo-platform && mvn clean install"
alias mvnbuildexo-portal="cd $EXO_SRC_CODE/exo-portal && mvn clean install"
alias mvnbuildexo-jcr="cd $EXO_SRC_CODE/exo-jcr && mvn clean install"
alias mvnbuildexo-ecm="cd $EXO_SRC_CODE/exo-ecm && mvn clean install"


alias mvnbuildportal="mvnbuildexo-platform && mvnbuildexo-portal &&
                      cd $EXO_SRC_CODE/exo-test && mvn clean install &&
                      cd $EXO_SRC_CODE/exo-assembly/portal &&
                      mvn clean install exo:platform -Ddeploy=tomcat"

alias mvnbuildecm="mvnbuildexo-platform && mvnbuildexo-portal && 
                   mvnbuildexo-jcr && mvnbuildexo-ecm
                   cd $EXO_SRC_CODE/exo-assembly/ecm &&
                   mvn clean install exo:platform -Ddeploy=tomcat"

alias mvntestportal="cd $EXO_SRC_CODE/exo-test/webunit-suites &&
                     mvn test -Dscript=suites/runner/PortalSuiteRunner.groovy &&
                     cdback"
                    
alias mvntestecm="cd $EXO_SRC_CODE/exo-test/webunit-suites &&
                  mvn test -Dscript=suites/runner/ECMPortalSuiteRunner.groovy &&
                  cdback"



alias svnupdatev2x="mvncleanecm && cdv2x && svn update"
alias svnModifiedFiles='svn st | grep "^M" '
alias svnConflictFiles='svn st | grep "^C" '

alias vibuild="vi $USER_HOME/build.properties"
alias visetting="vi $USER_HOME/.m2/settings.xml"

alias sql="mysql -t -u dev -pdev dev"

alias ldap=" cd /cygdrive/c/openldap && ./slapd -d 1 "

alias tomcatClean="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
                   rm -rf ../temp/* &&
                   rm -rf ../work/* &&
                   rm -rf ../logs/* "
   
alias tomcatRun="cd $EXO_WORKING_DIR/exo-tomcat/bin && chmod +x *.sh && ./exo-run.sh"

alias tomcatCleanRun="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
		                  rm -rf ../temp/* &&
                      rm -rf ../work/* &&
                      rm -rf ../logs/*  &&
                      chmod +x *.sh && ./exo-run.sh "

